package com.example.topse.fs;

import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

public class DummyFileSystem {

	static DummyFileSystem instance = new DummyFileSystem();	
	public static DummyFileSystem getInstance() {
		return instance;
	}
	
	private final Directory root = new Directory("");

	private DummyFileSystem() {
	}
	
	public Directory getRoot() {
		return root;
	}
	
	public boolean isRoot(FileNode directory) {
		return root == directory;
	}
	
	public String getPath(FileNode node) throws RuntimeException {
		DummyFileSystem filesystem = DummyFileSystem.getInstance();
		List<FileNode> hierarchy = new LinkedList<FileNode>();

		FileNode target = node;
		while (!filesystem.isRoot(target)) {
			hierarchy.add(target);
			target = target.getParent();
			if (target == null) {
				throw new RuntimeException();
			}
		}
		hierarchy.add(target);
		
		Collections.reverse(hierarchy);	
		
		StringBuffer buffer = new StringBuffer();
		for (FileNode item : hierarchy) {
			buffer.append(item.getName());
			if (item.isDirectory()) {
				buffer.append("/");
			}
		}

		return buffer.toString();
	}
	
	public void clear() {
		root.getChildren().clear();
	}
}
