package com.example.topse.shell.commands;


import static org.junit.Assert.*;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;		
import org.jmock.Expectations;
import org.jmock.Mockery;

import com.example.topse.shell.Shell;
import com.example.topse.shell.commands.ExitCommand;

public class ExitCommandTest {

	ExitCommand command = new ExitCommand();
	Mockery context = new Mockery();
	Shell shell = context.mock(Shell.class);
	
	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void testHandleExitCommandAndSetFinishedToShell() {
		context.checking(new Expectations() { {
			oneOf (shell).setFinished(true);
		} });
		boolean isFinished = command.execute(shell, "exit", null);

		context.assertIsSatisfied();
		assertTrue(isFinished);
	}

	@Test
	public void testDoesNotHandleOtherCommand() {
		boolean isFinished = command.execute(shell, "not_exit", null);
	
		context.assertIsSatisfied();
		assertFalse(isFinished);
	}

}
