package com.team2;

import static org.junit.Assert.*;

import java.io.ByteArrayInputStream;
import java.io.PrintWriter;
import java.io.StringWriter;

import org.junit.Before;
import org.junit.Test;

public class MainTest {
	
	private Main main = null;
	private StringWriter stringWriter = null;
	private PrintWriter pWriter = null;
	
	@Before
	public void before() {
		main = new Main();
		stringWriter = new StringWriter();
		pWriter = new PrintWriter(stringWriter);
	}
	
	
	@Test
	public void testMainShouldGetInputValueFromStream() throws Exception {
		main.setStream(new ByteArrayInputStream("value".getBytes()));
		assertEquals("value", main.getInput()[0]);
	}
	
	@Test
	public void testMainShouldGetInputMultiValueFromStream() throws Exception {
		main.setStream(new ByteArrayInputStream("value arg".getBytes()));
		String[] ret = main.getInput();
		assertEquals("value", ret[0]);
		assertEquals("arg", ret[1]);
	}
	
	
	
	@Test
	public void testMainShouldRecognizeCommandTypeExit() throws Exception {
		main.setStream(new ByteArrayInputStream("exit".getBytes()));
		main.setPrintWriter(pWriter);

		main.recieve();
		
		assertEquals("exit.\r\n", stringWriter.getBuffer().toString());
	}
	
	@Test
	public void testMainShuouldReturnErrorMessage() throws Exception {
		main.setStream(new ByteArrayInputStream("error".getBytes()));
		main.setPrintWriter(pWriter);

		main.recieve();
		
		assertEquals("Error Command Name\r\n", stringWriter.getBuffer().toString());
	}
	
	@Test
	public void testMainShloudRecognizeCommandPwd() throws Exception {
		main.setStream(new ByteArrayInputStream("pwd".getBytes()));
		main.setPrintWriter(pWriter);
		
		main.recieve();
		
		assertEquals("/\r\n", stringWriter.getBuffer().toString());
			
	}
			
	@Test
	public void testMainShloudRecognizeCommandMkdir() throws Exception {
		main.setStream(new ByteArrayInputStream("mkdir arg".getBytes()));
		main.setPrintWriter(pWriter);
		MkdirMock mock = new MkdirMock();
		main.setMkdir(mock);
		
		main.recieve();
		
		assertEquals("\r\n", stringWriter.getBuffer().toString());
		assertTrue(mock.flag);
	}
	
//	@Test
//	public void testMainShloudRecognizeCommandMkfile() throws Exception {
//		main.setStream(new ByteArrayInputStream("mkfile arg".getBytes()));
//		main.setPrintWriter(pWriter);
//		MkfileMock mock = new MkfileMock();
//		main.setMkfile(mock);
//		
//		main.recieve();
//		
//		assertEquals("\r\n", stringWriter.getBuffer().toString());
//		assertTrue(mock.flag);
//	}
	

};

class MkdirMock extends Mkdir {
	boolean flag = false;
	@Override
	public boolean excute(String targetDir) {
		flag = true;
		return true;				
	}
};

