package com.team2;

import static org.junit.Assert.*;

import java.util.List;

import org.junit.Test;

public class VirtualFSTest {

	VirtualFS fs = new VirtualFS();
	
	@Test
	public void testVirtualFSreturnsCurrentDirectory() {
		MyFile target = fs.getCurrentDir();
		assertEquals(FileType.directory, target.getFiletype());
		assertEquals("/", target.getStringPath());
	}
	
	@Test
	public void testVirtualFSmakeDirectory() {
		String targetDirectoryName = "test";
		assertTrue(fs.createDirectory(targetDirectoryName));
	}
	
	@Test
	public void testVirtualFSmakeFile() {
		String targetFileName = "test";
		assertTrue(fs.createFile(targetFileName));
	}
	
	@Test
	public void testVirtualFSreturnsChildren() {
		fs.createDirectory("testDir");
		fs.createFile("testFile");
		List<MyFile> children = fs.getChildren();
		assertEquals(2, children.size());
		boolean dirResult = false;
		boolean fileResult = false;
		for (MyFile myFile : children) {
			if ("testDir".equals(myFile.getStringPath())){
				dirResult = true;
			}else if("testFile".equals(myFile.getStringPath())){
				fileResult = true;
			}
		}
		
		assertTrue(dirResult);
		assertTrue(fileResult);
	}

}
